<?php

namespace Drupal\kompakkt\Plugin\Field\FieldType;

use Drupal\Core\Field\FieldItemBase;
use Drupal\Core\Field\FieldDefinitionInterface;
use Drupal\Core\Field\FieldStorageDefinitionInterface;
use Drupal\Core\TypedData\DataDefinition;

/**
 * Plugin implementation of the 'kompakkt_field' field type.
 *
 * @FieldType(
 *   id = "kompakkt_field",
 *   label = @Translation("Embed Kompakkt"),
 *   description = @Translation("Embed 3D model in pages."),
 *   category = @Translation("Media"),
 *   default_widget = "kompakkt_widget",
 *   default_formatter = "kompakkt_format"
 * )
 */
class KompakktItem extends FieldItemBase {

  /**
   * {@inheritdoc}
   */
  public static function schema(FieldStorageDefinitionInterface $field_definition) {
    return array(
      'columns' => array(
        'value' => array(
          'type' => 'text',
          'not null' => FALSE,
        ),
      ),
    );
  }

  /**
   * {@inheritdoc}
   */
  public function isEmpty() {
    $value = $this->get('value')->getValue();
    return $value === NULL || $value === '';
  }

  /**
   * {@inheritdoc}
   */
  public static function propertyDefinitions(FieldStorageDefinitionInterface $field_definition) {
    $properties['value'] = DataDefinition::create('string')
      ->setLabel(t('Target URL'));

    return $properties;
  }

}